recon_ecm = true
second_jammer = false
local tmp_vec1 = Vector3()
ECMJammerBase = ECMJammerBase or class(UnitBase)
ECMJammerBase._NET_EVENTS = {
	battery_low = 1,
	battery_empty = 2,
	feedback_start = 3,
	feedback_stop = 4,
	jammer_active = 5,
	feedback_flash = 6,
	feedback_restart = 7
}
ECMJammerBase.battery_life_multiplier = {
	1,
	1.25,
	1.5
}

local old_init = ECMJammerBase.init
function ECMJammerBase:init(unit) -- Need to mod this
    -- Run OVK Code 
    old_init(self, unit)
	-- Check if skill on
	if managers.player:has_category_upgrade("ecm_jammer", "recon_enabled") then
		log('recon_ENABLED!')
		recon_ecm = true
	end
	if Network:is_client() then
		self._validate_clbk_id = "ecm_jammer_validate" .. tostring(unit:key())
		managers.enemy:add_delayed_clbk(self._validate_clbk_id, callback(self, self, "_clbk_validate"), Application:time() + 60)
	end
end

function ECMJammerBase:mark_enemy_feedback()
	--subsimple GroupAIStateBase:register_ecm_jammer
	--Managers.mission:call_global_event("ecm_jammer_on", unit)
	-- Range mod as client here
	-- loud check managers.groupai:state():whisper_mode()
	log('AS_CLIENT_recon_ENABLED:'..tostring(recon_ecm))
	local range = tweak_data.upgrades.ecm_jammer_base_range
	local detected = World:find_units_quick("sphere", self._unit:position(), range, managers.slot:get_mask("enemies"))
	for _, unit in ipairs(detected) do
		if alive(unit:body("mover_blocker")) and recon_ecm then
			--Mod here
			unit:contour():add("mark_enemy_damage_bonus", true, 2)

			local col_ray = { }
			col_ray.ray = Vector3(1, 0, 0)
			col_ray.position = unit:position()
			local action_data = {}
			action_data.variant = "stun"
			action_data.damage = 0
			action_data.attacker_unit = nil
			action_data.col_ray = col_ray
		 
			unit:character_damage():damage_explosion(action_data)
		end
	end
end

local old_syncnetevent = ECMJammerBase.sync_net_event
function ECMJammerBase:sync_net_event(event_id)
    -- Run OVK Code 
    old_syncnetevent(self, event_id)
	local net_events = self._NET_EVENTS
	if event_id == net_events.battery_empty then
		log('battery_empty')
		second_jammer = false
	elseif event_id == net_events.feedback_start then
		if second_jammer == false then
			self:_send_net_event(self._NET_EVENTS.jammer_active)
			second_jammer = true
		end
		self:mark_enemy_feedback()	
	elseif event_id == net_events.feedback_stop then
		if second_jammer == true then
			second_jammer = false
			self:_send_net_event(self._NET_EVENTS.battery_empty)
			log("second_jammer stop")
		end
		log('feedback_stop')
	end
end


local old_detect_and_give_dmg = ECMJammerBase._detect_and_give_dmg
function ECMJammerBase._detect_and_give_dmg(hit_pos, device_unit, user_unit, range)
	old_detect_and_give_dmg(self, hit_pos, device_unit, user_unit, range)
	self:mark_enemy_feedback()	
end

