recon_ecm = false
recon_ecm_boost = false
second_jammer = false
recon_retrigger = false
local tmp_vec1 = Vector3()
ECMJammerBase = ECMJammerBase or class(UnitBase)
ECMJammerBase._NET_EVENTS = {
	battery_low = 1,
	battery_empty = 2,
	feedback_start = 3,
	feedback_stop = 4,
	jammer_active = 5,
	feedback_flash = 6,
	feedback_restart = 7
}
ECMJammerBase.battery_life_multiplier = {
	1,
	1.25,
	1.5
}
time = TimerManager:game():time()
retrigger_t = 10


local old_init = ECMJammerBase.init
function ECMJammerBase:init(unit) -- Need to mod this
    -- Run OVK Code 
    old_init(self, unit)
	-- Check if skill on
	if managers.player:has_category_upgrade("ecm_jammer", "recon_enabled") then
		log('recon_ENABLED!')
		recon_ecm = true
	end
	if managers.player:has_category_upgrade("ecm_jammer", "recon_dmg_boost") then
		log('recon_boost_ENABLED!')
		recon_ecm_boost = true
	end
	if managers.player:has_category_upgrade("ecm_jammer", "recon_retrigger") then
		log('recon_retrigger_ENABLED!')
		recon_retrigger = true
	end
	retrigger_t = tweak_data.upgrades.ecm_feedback_retrigger_interval -- managers.player:upgrade_value("weapon", "silencer_damage_multiplier", 1)
	if managers.player:has_category_upgrade("ecm_jammer", "recon_cooldown_boost") then
		log('recon_cooldown_boost!')
		retrigger_t = retrigger_t * managers.player:upgrade_value("ecm_jammer", "recon_cooldown_boost", 1)
		log('retrigger_t:'..tostring(retrigger_t))
	end
	if Network:is_client() then
		self._validate_clbk_id = "ecm_jammer_validate" .. tostring(unit:key())
		managers.enemy:add_delayed_clbk(self._validate_clbk_id, callback(self, self, "_clbk_validate"), Application:time() + 60)
	end
end

function ECMJammerBase:mark_enemy_feedback()
	--subsimple GroupAIStateBase:register_ecm_jammer
	--Managers.mission:call_global_event("ecm_jammer_on", unit)
	-- Range mod as client here
	-- loud check managers.groupai:state():whisper_mode()
	--log('recon_ENABLED:'..tostring(recon_ecm))
	local range = tweak_data.upgrades.ecm_jammer_base_range
	local detected = World:find_units_quick("sphere", self._unit:position(), range, managers.slot:get_mask("enemies"))
	for _, unit in ipairs(detected) do
		if alive(unit:body("mover_blocker")) and recon_ecm then
			-- Check if the mark will sync or not
			sync_ecm = MenuRecon:get_data()
			log('SyncFeedbackEcm:'..tostring(sync_ecm))
			if recon_ecm_boost then
				unit:contour():add("mark_enemy_damage_bonus", sync_ecm, 2)
			else
				unit:contour():add("mark_enemy", sync_ecm, 2)
			end		
			local col_ray = { }
			col_ray.ray = Vector3(1, 0, 0)
			col_ray.position = unit:position()
			local action_data = {}
			action_data.variant = "stun"
			action_data.damage = 0
			action_data.attacker_unit = nil
			action_data.col_ray = col_ray
		 
			unit:character_damage():damage_explosion(action_data)
		end
	end
end

local old_syncnetevent = ECMJammerBase.sync_net_event
function ECMJammerBase:sync_net_event(event_id)
    -- Run OVK Code 
    old_syncnetevent(self, event_id)
	local net_events = self._NET_EVENTS
	if event_id == net_events.battery_empty then
		log('battery_empty')
		second_jammer = false
	elseif event_id == net_events.feedback_start then
		if second_jammer == false and recon_retrigger then
			self:_send_net_event(self._NET_EVENTS.jammer_active)
			second_jammer = true
			log("second_jammer start")
		end
		self:mark_enemy_feedback()	
	elseif event_id == net_events.feedback_stop then
		if second_jammer == true and recon_retrigger then
			second_jammer = false
			self:_send_net_event(self._NET_EVENTS.battery_empty)
			log("second_jammer stop")
		end
		DelayedCalls:Add( "DelayedCallsRetrigger", retrigger_t, function()
			self:_send_net_event(self._NET_EVENTS.feedback_restart)
    		self._unit:sound_source():post_event("ecm_jammer_ready")
			self._unit:interaction():set_active(true, true)
			end )	 
		log('feedback_stop')
	end
end

local old_clbk_feedback = ECMJammerBase.clbk_feedback
function ECMJammerBase:clbk_feedback()
	old_clbk_feedback(self)
	self:mark_enemy_feedback()	
end

--Host Cooldown
local old_set_feedback_active = ECMJammerBase._set_feedback_active
function ECMJammerBase:_set_feedback_active(state)
	old_set_feedback_active(self, state)
	self._chk_feedback_retrigger_t = retrigger_t
end
